/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2024/02/04 18:18:04
 */

//导出svg的配置
export const DEFAULT_EXPORT_OPTIONS = {
  width: '100px',
  height: '100px'
}

//path 保留小数位
export const PATH_DECIMAL = 4

export const FONT_FAMILY = 'iconfont'

//默认的配置参数
export const DEFAULT_OPTIONS = {
  font: {
    id: FONT_FAMILY,
    horizAdvX: 1024,
    vertAdvY: 1024
  },
  fontface: {
    fontFamily: FONT_FAMILY,
    fontWeight: '400',
    fontStretch: 'normal',
    unitsPerEm: '1024',
    ascent: '812',
    descent: '-212'
  },
  glyph: {
    unicode: '',
    glyphName: '',
    d: '',
    horizAdvX: 1024,
    vertAdvY: 1024
  }
}

export const FONT_TMPL = `
<?xml version="1.0" standalone="no"?>
  <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd" >
  <svg>
  <metadata>Created by @bytedo/font-generator</metadata>
  <defs>
  <font id="${font.id}" horiz-adv-x="${font.horizAdvX}" vert-adv-y="${
  font.horizAdvX
}" >
    <font-face ${Object.keys(fontface)
      .map(k => `${k}="${fontface[k]}"`)
      .join(' ')} />
    
    <missing-glyph />

    ${
      hasX
        ? ''
        : '<glyph glyph-name="x" unicode="&#x78;" horiz-adv-x="100" d="M20 20 L50 20 L50 -20 Z" />'
    }

    ${glyphs
      .map(
        glyph =>
          `<glyph glyph-name="${glyph.glyphName}" unicode="${
            glyph.unicode
          }" d="${glyph.d}" ${
            glyph.horizAdvX ? `horiz-adv-x="${glyph.horizAdvX}"` : ''
          } ${glyph.vertAdvY ? `vert-adv-y="${glyph.vertAdvY}"` : ''} />`
      )
      .join('\n')}
  </font>
  </defs>
</svg>
`

export const SVG_TMPL = `
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
  <svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" ${
    options.skipViewport
      ? ''
      : `x="0" y="0" width="${options.width}" height="${options.height}"`
  } viewBox="0 0 ${glyph.horizAdvX} ${glyph.vertAdvY}">
  <path d="${glyph.d}"/>
</svg>
`
